Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.c
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1483)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1484)
@@ -73,8 +73,7 @@
  * it is Mandatory or not. The data currently in the document does not
  * match what was in the previous version of the freeDiameter
- * extension (the one that existedbefore I rewrote it) or what I saw
+ * extension (the one that existed before I rewrote it) or what I saw
  * so far. IIRC, even the table and the document contradict each
- * other. The AVP table is also missing an entry for
- * "External-Identifier", 28.
+ * other.
  *
  * 2. 29.140 has conflicting AVP names with other documents:
@@ -738,17 +737,11 @@
 	};
 
-	/* added manually, missing in AVP table                             */
-	/* External-Identifier, OctetString, code 28, section 16.4.7        */
-	{
-		struct dict_avp_data data = {
-			28,	/* Code */
-			10415,	/* Vendor */
-			"External-Identifier",	/* Name */
-			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flags */
-			AVP_FLAG_VENDOR,	/* Fixed flag values */
-			AVP_TYPE_OCTETSTRING	/* base type of data */
-		};
-		CHECK_dict_new(DICT_AVP, &data, NULL, NULL);
-	};
+	/* Note: 3GPP TS 29.061 table 9a does not define                    */
+	/* External-Identifier (28) for Diameter.                           */
+	/* 3GPP TS 29.061 table 9b refers to 3GPP TS 29.336                 */
+	/* for External-Identifier (3111).                                  */
+	/*                                                                  */
+	/* External-Identifier (28) OctetString replaced by                 */
+	/* External-Identifier (3111) UTF8String.                           */
 
 	/* TMGI, OctetString, code 900, section 17.07.02                    */
@@ -8769,4 +8762,28 @@
 		};
 		CHECK_dict_new(DICT_AVP, &data, NULL, NULL);
+	};
+
+	/*==================================================================*/
+	/* 3GPP TS 29.336 V15.7.0 (2019-09)                                 */
+	/* From 3GPP 29336-f70.docx                                         */
+	/*==================================================================*/
+
+	/*==================================================================*/
+	/* 3GPP TS 29.336 Table 6.4.1/1: S6m/S6n specific Diameter AVPs     */
+	/*                                                                  */
+	/* Note: This is incomplete.                                        */
+	/*==================================================================*/
+
+	/* External-Identifier, UTF8String, code 3111, section 6.4.11       */
+	{
+		struct dict_avp_data data = {
+			3111,	/* Code */
+			10415,	/* Vendor */
+			"External-Identifier",	/* Name */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flags */
+			AVP_FLAG_VENDOR |AVP_FLAG_MANDATORY,	/* Fixed flag values */
+			AVP_TYPE_OCTETSTRING	/* base type of data */
+		};
+		CHECK_dict_new(DICT_AVP, &data, UTF8String_type, NULL);
 	};
 
Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1483)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1484)
@@ -57,6 +57,12 @@
 3GPP-Negotiated-DSCP,26,16.4.7,OctetString,V,P,,M,
 3GPP-Allocate-IP-Type,27,16.4.7,OctetString,V,P,,M,
-"# added manually, missing in AVP table",,,,,,,,
-External-Identifier,28,16.4.7,OctetString,V,P,,M,
+# Note: 3GPP TS 29.061 table 9a does not define,,,,,,,,
+# External-Identifier (28) for Diameter.,,,,,,,,
+# 3GPP TS 29.061 table 9b refers to 3GPP TS 29.336,,,,,,,,
+# for External-Identifier (3111).,,,,,,,,
+# ,,,,,,,,
+# External-Identifier (28) OctetString replaced by,,,,,,,,
+# External-Identifier (3111) UTF8String.,,,,,,,,
+#,,,,,,,,
 TMGI,900,17.07.02,OctetString,"M,V",P,,,
 Required-MBMS-Bearer-Capabilities,901,17.07.03,UTF8String,"M,V",P,,,
@@ -809,4 +815,18 @@
 Call-Reference-Number,721,6.3.30,OctetString,V,,,M,No
 AS-Number,722,6.3.31,OctetString,V,,,M,No
+,,,,,,,,
+@standard,3GPP TS 29.336,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.336 V15.7.0 (2019-09),,,,,,,,
+# From 3GPP 29336-f70.docx,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.336 Table 6.4.1/1: S6m/S6n specific Diameter AVPs,,,,,,,,
+# ,,,,,,,,
+# Note: This is incomplete.,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+External-Identifier,3111,6.4.11,UTF8String,"M,V",,,,No
 ,,,,,,,,
 @standard,3GPP TS 32.299,,,,,,,
